#ifndef __PLUGIN_H__
#define __PLUGIN_H__

#include "input.h"
#include "decaps.h"
#include "decoder.h"
#include "id.h"

// otherwise we would have to dereference a void pointer - seems we don't
//	like to do that ;)

#define PLUGIN_OPS_INPUT(x)	((plugin_input_t *)((x)->ops[PLUGIN_ID_INPUT]))
#define PLUGIN_OPS_DECAPS(x)	((plugin_decaps_t *)((x)->ops[PLUGIN_ID_DECAPS]))
#define PLUGIN_OPS_NAV(x)	((plugin_nav_t *)((x)->ops[PLUGIN_ID_NAV]))
#define PLUGIN_OPS_CODEC(x)	((plugin_codec_t *)((x)->ops[PLUGIN_ID_CODEC]))
#define PLUGIN_OPS_OUTPUT(x)	((plugin_output_t *)((x)->ops[PLUGIN_ID_OUTPUT]))


#define DL_INPUT_UDF	"input_udf.so"
#define DL_INPUT_FILE	"input_file.so"
#define DL_INPUT_VCD	"input_vcd.so"
#define DL_NAV_DVD	"nav_dvd.so"
#define DL_NAV_VCD	"nav_vcd.so"
#define DL_NAV_FILE	"nav_file.so"
#define DL_DECAPS_PS	"decaps_ps.so"
#define DL_DECAPS_TS	"decaps_ts.so"
#define DL_DECAPS_VCD	"decaps_vcd.so"

/***** summary of all plugins *****/

typedef struct {
        void *handle[MAX_PLUGIN_ID];
        void *ops[MAX_PLUGIN_ID];
} plugin_t;

/***** prototypes ******/

void *_pluginOpen (plugin_t *plugin, u_int plugin_id, char *plugin_name);
int pluginOpen (plugin_t *plugin, u_int plugin_id, char *plugin_name, void *data);
void *pluginClose (plugin_t *plugin, u_int plugin_id);

//void *plugin_init (void *);	// initialize plugin
void plugin_exit (void);	// clean up plugin
#endif
